--- chan_sip.c.orig	2009-12-22 21:23:28.000000000 +0100
+++ chan_sip.c	2009-12-22 21:44:08.000000000 +0100
@@ -22766,7 +22766,9 @@
 				}
 				if (ast_true(registersip) || (!registersip && genregistersip)) {
 					char tmp[256];
+					char host_port[256];
 					const char *host = ast_variable_retrieve(ucfg, cat, "host");
+					const char *port = ast_variable_retrieve(ucfg, cat, "port");
 					const char *username = ast_variable_retrieve(ucfg, cat, "username");
 					const char *secret = ast_variable_retrieve(ucfg, cat, "secret");
 					const char *contact = ast_variable_retrieve(ucfg, cat, "contact");
@@ -22780,16 +22782,20 @@
 					if (!contact)
 						contact = "s";
 					if (!ast_strlen_zero(username) && !ast_strlen_zero(host)) {
+						if (port && (atoi(port) != STANDARD_SIP_PORT))
+							snprintf(host_port, sizeof(host_port), "%s:%s", host, port);
+						else
+							snprintf(host_port, sizeof(host_port), "%s", host);
 						if (!ast_strlen_zero(secret)) {
 							if (!ast_strlen_zero(authuser)) {
-								snprintf(tmp, sizeof(tmp), "%s:%s:%s@%s/%s", username, secret, authuser, host, contact);
+								snprintf(tmp, sizeof(tmp), "%s:%s:%s@%s/%s", username, secret, authuser, host_port, contact);
 							} else {
-								snprintf(tmp, sizeof(tmp), "%s:%s@%s/%s", username, secret, host, contact);
+								snprintf(tmp, sizeof(tmp), "%s:%s@%s/%s", username, secret, host_port, contact);
 							}
 						} else if (!ast_strlen_zero(authuser)) {
-							snprintf(tmp, sizeof(tmp), "%s::%s@%s/%s", username, authuser, host, contact);
+							snprintf(tmp, sizeof(tmp), "%s::%s@%s/%s", username, authuser, host_port, contact);
 						} else {
-							snprintf(tmp, sizeof(tmp), "%s@%s/%s", username, host, contact);
+							snprintf(tmp, sizeof(tmp), "%s@%s/%s", username, host_port, contact);
 						}
 						if (sip_register(tmp, 0) == 0)
 							registry_count++;
